/************************************************************
	t@C:main.c
	Tv:xZT̒l擾ƕ\
	^[Qbg:PIC16F88(20MHz)
	|[gA:AiO(RA0, RA1)A(RA2, RA3)
	|[gB:LED(RB0-RB7)
	쐬:2012/07/20
************************************************************/

//et@C̃CN[h

#include "common.h"
#include "ad.h"
#include "display.h"

//RtBO[Vrbg̐ݒ
__CONFIG(FOSC_HS & WDTE_OFF & PWRTE_OFF & MCLRE_ON & BOREN_OFF &
	LVP_OFF & CPD_OFF & WRT_OFF & CCPMX_RB3 & CP_OFF & DEBUG_OFF);
__CONFIG(FCMEN_OFF & IESO_OFF);

#define BEEP_CYCLE	0xB5	//uU[̔(7IN^[ũh̉K)
#define DISP_CYCLE	0xCF2C
#define DISP_LOW	(unsigned char)(DISP_CYCLE & 0xFF)
#define	DISP_HIGH	(unsigned char)(DISP_CYCLE >> 8)

//XCb`̒u(_Őڑ)
#define PSW1	RA2		//{^XCb`1RA2ɐڑ
#define PSW2	RA3		//{^XCb`1RA3ɐڑ
#define SW_ON	0		//{^XCb`ON
#define SW_OFF	1		//{^XCb`OFF

//vg^Cv錾
void interrupt isr(void);
void io_init(void);
void tmr0_init(void);
void tmr1_init(void);
unsigned short move_average(unsigned short add);

//O[oϐE萔
unsigned char seg[4];

#define AVERAGE_COUNT	3	//ړς̐3 = 23 = 8̕ς


//main֐
void main(void)
{
	unsigned short temp;	//x̒l(25.6 => 2560)
	unsigned short ave;		//ړϒl
	unsigned char i;

	io_init();			//I/Ȍ
    tmr0_init();		//^C}0̏
    tmr1_init();		//^C}1̏
	ad_init();			//A/D̏

	//݂̐ݒ
	TMR0IE = 0;			//TMR0݋֎~(̏ŋ)
	PEIE = 1;			//Ӌ@\݋
	GIE = 1;			//S݋

    while (1) {				//[v
		dec2temp(seg, 0);
		i = 50;
		//XCb`1OFF̂Ƃȉ̃[v
		while (PSW2 == SW_OFF) {	//͑҂p\(0000_)
			while (i--) seg_disp4(seg);
			SEG_OFF();
			__delay_ms(400);
			continue;
		}

		TMR1IF = 0;				//tO
		TMR1IE = 1;				//^C}0݋

		while (1) {
			//xZTA/Dϊ100mV/Ƃđ
			temp = (unsigned short long)ad_get(1) * 5000 >> 10;
			ave = move_average(temp);	//ړϒl̎Zo
			dec2temp(seg, ave);			//"25.6c"̂悤ɕ\
			//xl(30)ȏ̂Ƃ
			if (ave >= (ad_get(0) << 2)) break;
			__delay_ms(20);		//A/Dϊ̃TvO(K)
		}
		//uU[o
		TMR0IF = 0;				//tO
		TMR0IE = 1;				//^C}0݋T
		//XCb`2ONɂȂ܂Ń[v
		while(PSW2 == SW_OFF)	;
		TMR0IE = 0;				//^C}0݋֎~
		TMR1IF = 0;				//tO
		TMR1IE = 0;				//^C}0݋
	}
}

//I/O֐
void io_init(void)
{
	ANSEL = 0x03;				//RA0RA1AiÓAfBW^I/O
	TRISA = 0x0F;				//RA0?RA3́Ao
	TRISB = 0x00;				//PORTBSo
	PORTB = 0x00;				//7ZO͑SOFF()
}

//^C}0֐
void tmr0_init(void)
{
    T0CS = 0;				//VXeNbNJEg
	PSA = 0;				//vXP[gp
	PS2 = 0;				//vXP[1/16
	PS1 = 1;				
	PS0 = 1;				
	TMR0 = BEEP_CYCLE;		//^C}̏l
}

//^C}1֐
void tmr1_init(void)
{
	T1CKPS0 = 0;			//vXP[1:1
	T1CKPS1 = 0;
	T1OSCEN = 0;			//OIV[^p[It
	TMR1CS = 0;				//Fosc/4(0.2us)gp
	TMR1ON = 1;				//^C}L
	TMR1L = DISP_LOW;			//65536 - 12500 = 53036 = 0xCF2C
	TMR1H = DISP_HIGH;			//0.2us x 12500 = 2.5ms
}

//݊֐
void interrupt isr(void)
{
	static unsigned char i = 0;			//̐ؑ֗pÓIϐ

	//^C}0(uU[)
	if (TMR0IF & TMR0IE) {					//TMR0tOo
		RA4 = !RA4;					//uU[̐M𔽓]
		TMR0 = BEEP_CYCLE;
		TMR0IF = 0;					//TMR0tO
	}

	//^C}1(2msɔ)
	if (TMR1IF & TMR1IE) {					//TMR1tOo
		if (i++ >= 3) {			//3\ςo
			i = 0;				//
		}
		SEG_OFF();				//
		if (i == 2) {	//hbg|Cg̗L
			SEG_ON_DP(i, seg[i]);	//hbg|Cg܂߂ĕ\
		}
		else {
			SEG_ON(i, seg[i]);	//hbg|CgȂŕ\
		}
		TMR1L = DISP_LOW;			//65536 - 12500 = 53036 = 0xCF2C
		TMR1H = DISP_HIGH;			//0.2us x 12500 = 2.5ms
		TMR1IF = 0;					//TMR1tO
	}
}

//ړϗp̊֐(Ăяo͔z̊evf0)
//ZgȂ̂ŃrbgVtgKp
unsigned short move_average(unsigned short add)
{
	static unsigned char index;		//֑Ώۂ̗vfԍ
	static unsigned short sum, array[1 <<  AVERAGE_COUNT];
	
	sum -= array[index];	//ŌẪf[^v폜
	array[index] = add;		//ŐṼf[^ŌÂ̏ꏊɒǉ
	sum += array[index];	//ŐṼf[^vlɒǉ
	
	index++;			//ւvfԍ+1
	//ϐ8̂Ƃ index = index & (0x07)Ɠ
	index &= (1 << AVERAGE_COUNT) - 1;	//vfԍ͈̔͂𒴂Ȃ悤Ƀ}XN

	return sum >> AVERAGE_COUNT;		//vl畽όZĕϒl
}
